.model small
.386
.stack 300h

.DATA 
	;-----------
	; Bloco de variaveis
	;Mensagens de erro
	pause db 0
	help db 0
	ultimoScore dw ?
	f1LogoName db "imagens/logohelp.dat", 0
	f1Logo db 1860 dup(?)
	msgErroAbrirArquivo db "Erro ao abrir arquivo$"
	msgErroLeituraArquivo db "Erro na leitura do arquivo$"
	;Buffer para a leitura do arquivo
	fileReadBuffer db ?
	;Variavel q contm o arquivo da paleta de cores
	paletaName db "imagens/paleta.pal", 0  ;tem que ter o \0 no final
	;Varivel que contm a paleta na memoria
	paleta db 768 dup(?) ;array de 768 posicoes inicializando com 0.
	;Variavel q contem o arquivo do pau
	pauName db "imagens/barrinha.dat", 0
	pau db 528 dup(0) ;array de 528 posicoes inicializando com 0.
	bolinha db 36 dup(?)
	bolinhaName db "imagens/bolinha.dat",0
	logoName db "imagens/cubes.dat", 0
	logo db 700 dup(?)
	helpName db "imagens/help.dat",0
	direcaoPau db 0
	posicaoPau dw 59920 ;(linha 187, coluna 88)
	posicaoPauX dw 80
	posicaoPauY	dw 187
	posicaoBolinhaX dw 95
	posicaoBolinhaY dw 180
	posicaoBolinha dw 57695
	bloco1 db 100 dup (?)
	;bloco1Name db "imagens/bloco1.dat", 0
	bloco1Name db "bloco1.dat", 0
	bloco2 db 100 dup (?)
	bloco2Name db "imagens/bloco2.dat", 0
	bloco3 db 100 dup (?)
	bloco3Name db "imagens/bloco3.dat", 0
	;O bloquinho especial q caem coisas dele :)
	blocoEspecial db 100 dup (?)
	blocoEspecialName db "imagens/especial.dat", 0
	vetorDirecaoBolinhaX dw -2
	vetorDirecaoBolinhaY dw -2
	tickrate dw 0
	corFundo db 185
	acabou db 0
	boxsName db "boxs01.bin",0
	;boxsName1 db "boxs1.bin",0
	;boxsName2 db "boxs2.bin",0
	telaAbertura db "imagens/abertura.dat", 0 
	coracao db 405 dup(?)
	carinha db 405 dup(?)
	pocao db 405 dup(?)
	coracaoName db "imagens/coracao.dat", 0 
	carinhaName db "imagens/carinha.dat", 0 
	pocaoName db "imagens/pocao.dat", 0 
	telaGameOver db "imagens/fim.dat", 0 
	telaZerou db "imagens/zerou.dat", 0
	jogarNovamente db 0
	;Nmero de estgios total
	numeroEstagios db 0
	;Nmero de quadrados visveis
	numeroQuadrados db 0	
	boxs db 105 dup(0)
	itoaReturn db 6 dup(0)
	pontos dw 0
	inicioBoxsX dw 16
	inicioBoxsY dw 24
	vidas dw 0
	arquivoPontos db "aP.txt",0
	bolinhaParada db 1
	mudouEstagio db 0
	;Variavel q informa qual o numero da sprite q esta no momento
	spriteAtualCoracao db 0
	spriteAtualCarinha db 0
	spriteAtualPocao db 0
	
	;Contador que a cada timer ele incrementa um e quando chegar em um numero ele 
	;muda a sprite q esta sendo mostrada
	contador dw 0
	
	;Variveis que vo controlar as posices das sprites
	coracaoPosX dw 0
	coracaoPosY dw 0
	coracaoPos dw 0
	pocaoPosX dw 0
	pocaoPosY dw 0
	pocaoPos dw 0
	carinhaPosX dw 0
	carinhaPosY dw 0
	carinhaPos dw 0
	
	;Variveis que dizem se as sprites estao sendo mostradas na tela ou nao
	coracaoEnable db 0
	pocaoEnable db 0
	carinhaEnable db 0
	
	;Variveis com os labels q eu quero escrever na tela
	lblPontos db "Pontos: ", 0
	lblVidas db "Vidas: ", 0
	lblEstagio db "Nivel: ", 0
	lblHiScore db "TheOne:", 0
	passaLotado db 0
	timerPocao db 0
	
	;-----------------
	; Bloco de constantes
	larguraBox		equ word ptr 10 ; constante
	alturaBox		equ word ptr 10 ; constante
	separacaoBoxsX	equ word ptr  2 ; constante
	separacaoBoxsY	equ word ptr  2 ; constante
	boxsPorLinha	equ word ptr 15 ; constante
	totalEstagios equ byte ptr 3
	alturaBarrinha equ word ptr 8
	larguraBarrinha equ word ptr 40
	alturaBolinha equ word ptr 6
	larguraBolinha equ word ptr 6
	fimTela equ word ptr 206
	comecoTela equ word ptr 2
	numeroVidas equ word ptr 4
	
	posicaoBarrinhaXInicial equ word ptr 80
	posicaoBarrinhaYInicial equ word ptr 187
	posicaoBarrinhaInicial  equ word ptr 59920
	posicaoBolinhaXInicial  equ word ptr 95
	posicaoBolinhaYInicial  equ word ptr 181
	posicaoBolinhaInicial   equ word ptr 58015
	
	spriteAltura equ word ptr 9
	spriteLargura equ word ptr 10
	numeroSprites equ word ptr 4
	limiteVida equ word ptr 1000	

	;Numero de chamadas de timer que vai esperar
	numeroTimer equ word ptr 8
	
	;Numero q representa o quadradinho especial no arquivo de estagios
	numeroEspecial equ word ptr 4
	
.CODE

PAU_PARADO	equ 0
PAU_ESQ		equ 1
PAU_DIR		equ 2


;Funo que anima
animar proc near
	pusha
	cmp timerPocao, 0
	jne naoAcabaPocao
	mov passaLotado, 0
naoAcabaPocao:
	;Verifco se o contador ja chegou no numero
	;especificado para eu poder mudar a sprite atual
	cmp contador, numeroTimer
	je mudaSprite
	jmp finalAnimar
	
mudaSprite:	
	;Zero o contador
	mov contador, 0
	;decrementa o timer da pocao
	dec timerPocao
	;Vejo se eu ja cheguei na ultima sprite da animacao, se sim eu tenhoq voltar para o numero 0
	inc spriteAtualCarinha
	cmp spriteAtualCarinha, numeroSprites
	je zeraCarinha
	
verificaCoracao:
	;Vejo se eu ja cheguei na ultima sprite da animacao, se sim eu tenhoq voltar para o numero 0
	inc spriteAtualCoracao
	cmp spriteAtualCoracao, numeroSprites
	je zeraCoracao

verificaPocao:
	;Vejo se eu ja cheguei na ultima sprite da animacao, se sim eu tenhoq voltar para o numero 0
	inc spriteAtualPocao
	cmp spriteAtualPocao, numeroSprites
	je zeraPocao

verificaCarinha:
	;Vejo se eu ja cheguei na ultima sprite da animacao, se sim eu tenhoq voltar para o numero 0
	inc spriteAtualCarinha
	cmp spriteAtualCarinha, numeroSprites
	je zeraCarinha
	jmp finalAnimar

zeraCarinha:
	mov spriteAtualCarinha, 0
	jmp verificaCoracao

zeraCoracao:
	mov spriteAtualCoracao, 0
	jmp verificaPocao
	
zeraPocao:
	mov spriteAtualPocao, 0
	
finalAnimar:
	;Incremento o contador
	inc contador
	popa
	ret
	
animar endP

;Funo que conta quantos boxes ativos existem
contaBoxes proc near
	pusha
	;Zero o indice do array
	mov bx, 0
	mov numeroQuadrados, 0
	;Comeco do loop
	comecoLoop:
		;Vejo se ja chegou no final do array q estou percorrendo
		cmp bx, size boxs
		je fimLoop
		;Se ele eh zero eu incremento o indice e volto pro comeco do loop
		cmp boxs[bx], 0
		je incrementaIndice
		;Se ele nao eh 0 eu incremento o numero de quadrados
		inc numeroQuadrados
	incrementaIndice:
		inc bx
		jmp comecoLoop
	fimLoop:
		popa
		ret
contaBoxes endP

putPixel macro x, y, cor ; x: coluna, y: linha
	pusha ; salva os registratores
	push x
	push y
	push cor
	call putPixelProc	
	popa ; recupera os registradores
endM

; Parametros do procedimento
; putPixel
;
x 		equ 8[bp] ;coluna
y 		equ 6[bp] ;linha
cor 	equ 4[bp] ;cor
putPixelProc proc near	
	push bp
	mov bp, sp
	
	mov bx, y
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, x
	add ax, cx
	;escreve na memoria de video
	mov di, ax
	mov ax, cor
	stosb
	pop bp ; pega o ponteiro d apilha denovo
	ret 6 ; a pilha volta 6 posicoes (diminui 8 - 2(PC) )
putPixelProc endP

;---------------------------------------------------------
; seta a paleta de video
setarPaleta macro enderecoPaletaMemoria, numeroCores
	push enderecoPaletaMemoria
	push numeroCores
	call setarPaletaProc
endM

;---------------------------------------------------------
; carrega o bitmap de um arquivo e coloca na varivel 
; apontada por enderecoBitmap
carregarBitmap macro bitmapName, enderecoBitmap
	;colocar es na pilha 
	push es 
	; es aponta p/ o valor do segmento de dados ( tem que fazer esta GAMBI porque nao pode setar regs 
	; de segmento em reg de segmento.)
	push ax
	mov ax, ds
	mov es, ax
	pop ax
	;coloca di na pilha
	push di
	;apontar p/ inicio da varivel que vai guardar o pau ( o array ).
	mov di, enderecoBitmap
	; coloca pauName na pilha
	push bitmapName
	;chama o carregar arquivo
	call carregarArquivoProc
	; tira o di da pilha.
	pop di
	;tira o es da pilha.
	pop es
endM


desenharBitmapPosicao macro enderecoBitmap1, posicaoBitmap1, alturaBitmap1, larguraBitmap1
	push enderecoBitmap1
	push posicaoBitmap1
	push alturaBitmap1
	push larguraBitmap1
	call desenharBitmapPosicaoProc
endM


;---------------------------------------------------------
; desenha um bitmap numa determinada posicao na tela
;@param enderecoBitmap endereco da memoria onde estah o bitmap
enderecoBitmap	equ 10[bp]
;@param posicaoBitmap posicao linear inicial do bitmap na tela
posicaoBitmap	equ  8[bp]
;@param alturaBitmap altura do bitmap
alturaBitmap	equ  6[bp]
;@param larguraBitmap largura do bitmap
larguraBitmap	equ  4[bp]
;----------------------------------------------
;variveis locais
linhaAtual 		equ -2[bp]
pixelAtual		equ -4[bp]
ultimoPixel		equ -6[bp]
TRANSPARENTE	equ 7
desenharBitmapPosicaoProc proc near
	push bp
	mov bp, sp
	add sp, -6
	;coloca todos na pilha.
	pusha
	;guarda o di
	push di
	;inicializa a linha atual com a posicao linear atual
	;do bitmap
	mov ax, posicaoBitmap
	mov linhaAtual, ax
	;inicializa pixelAtual com o primeiro pixel
	mov ax, enderecoBitmap
	mov pixelAtual, ax
	;calcula o endereco do ultimo pixel = (primeiro pixel) + (altura*largura)
	mov ax, enderecoBitmap
	mov ultimoPixel, ax
	;coloco em ax a altura do bitmap e em bx a largura para poder multiplicar
	;pois a sintaxe de mul eh pegar o q tem em ax multiplicar com o parametro e jogar em ax
	mov ax, alturaBitmap
	mov bx, larguraBitmap
	mul bx 
	;adiciono o resultado da multiplicacao com o comeco do bitmap para saber o pixel final
	add ultimoPixel, ax
	;limpa o flag de direo 
	cld
	;zero cx que eh usado como o contador de coluna
	mov cx, 0
	;coloco em di que eh o contador de linha
	mov di, linhaAtual
	;coloca em bx o ultimo pixel do bitmap para saber quando o bitmap acabou
	mov dx, ultimoPixel
	mov bx, pixelAtual
	;label q da o loop na linha
	loopLinha: 
	   ;move o caralho do conteudo desta merda do pixel atual
	   ;para al
	   mov al, [bx]
	   mov ah, 0
	   cmp al, TRANSPARENTE
	   jne imprimePixel
		inc di
		jmp continua
	imprimePixel:
		stosb
	continua:
		;incrementa o pixel atual
		inc bx
		;incrementa o contador de colunas
		inc cx
		;compara o pixel atual com o pixel final
		cmp bx, dx
		je fimBitmap
		cmp cx, larguraBitmap
		je proximaLinha
		
		jmp loopLinha
		proximaLinha:
			xor cx, cx
			;vai para a proxima linha na tela (soma com 320 = 140h)
			add linhaAtual, word ptr 140h 
			mov di, linhaAtual
			jmp loopLinha
		
	fimBitmap:
		pop di
		popa
		add sp, 6
		pop bp
		ret 8	
desenharBitmapPosicaoProc endP


;---------------------------------------------------------
; desenha um sprite numa determinada posicao na tela
indiceSpriteDS equ 12[bp]
;@param enderecoSpriteDS endereco da memoria onde estah o bitmap
enderecoSpriteDS	equ 10[bp]
;@param posicaoSpriteDS posicao linear inicial do bitmap na tela
posicaoSpriteDS	equ  8[bp]
;@param alturaSpriteDS altura do bitmap
alturaSpriteDS	equ  6[bp]
;@param larguraSpriteDS largura do bitmap
larguraSpriteDS	equ  4[bp]
;----------------------------------------------
;variveis locais
linhaAtualDS 		equ -2[bp]
pixelAtualDS		equ -4[bp]
ultimoPixelDS		equ -6[bp]
contadorPixelDS	equ -8[bp]
;TRANSPARENTE	equ 0
desenharSpritePosicaoProc proc near
	push bp
	mov bp, sp
	add sp, -8
	;coloca todos na pilha.
	pusha
	;guarda o di
	push di
	;inicializa a linha atual com a posicao linear atual
	;do bitmap
	mov ax, posicaoSpriteDS
	mov linhaAtualDS, ax
	;inicializa pixelAtualDS com o primeiro pixel
	mov ax, enderecoSpriteDS
	mov pixelAtualDS, ax
	;calcula o endereco do ultimo pixel = (primeiro pixel) + (altura*largura)
	mov ax, enderecoSpriteDS
	mov ultimoPixelDS, ax
	;coloco em ax a altura do bitmap e em bx a largura para poder multiplicar
	;pois a sintaxe de mul eh pegar o q tem em ax multiplicar com o parametro e jogar em ax
	mov ax, alturaSpriteDS
	mov bx, larguraSpriteDS
	mul bx 
	;adiciono o resultado da multiplicacao com o comeco do bitmap para saber o pixel final
	add ultimoPixelDS, ax
	;limpa o flag de direo 
	cld
	;zero cx que eh usado como o contador de coluna
	mov cx, 0
	;coloco em di que eh o contador de linha
	mov di, linhaAtualDS
	;coloca em bx o ultimo pixel do bitmap para saber quando o bitmap acabou
	mov dx, ultimoPixelDS
	mov bx, pixelAtualDS
	;label q da o loop na linha
	loopLinhaDS: 
	   ;move o caralho do conteudo desta merda do pixel atual
	   ;para al
	   mov al, [bx]
	   mov ah, 0
	   cmp al, TRANSPARENTE
	   jne imprimePixel
		inc di
		jmp continua
	imprimePixelDS:
		stosb
	continuaDS:
		;incrementa o pixel atual
		inc bx
		;incrementa o contador de colunas
		inc cx
		;compara o pixel atual com o pixel final
		cmp bx, dx
		je fimBitmap
		cmp cx, larguraSpriteDS
		je proximaLinha
		
		jmp loopLinha
		proximaLinhaDS:
			xor cx, cx
			;vai para a proxima linha na tela (soma com 320 = 140h)
			add linhaAtualDS, word ptr 140h 
			mov di, linhaAtualDS
			jmp loopLinha
		
	fimBitmapDS:
		pop di
		popa
		add sp, 8
		pop bp
		ret 10	
desenharSpritePosicaoProc endP


;---------------------------------------------------------
; setarPaletaProc
enderecoPaletaMemoria equ 6[bp]
numeroCores				 equ 4[bp]
; seta a paleta do sistema
; @param enderecoPaletaMemoria Endereco da variavel que 
;			contm a paleta
; @param numeroCores Numero de cores da paleta
; o que esta no 2[bp]  o PC e o que que estah no 0[bp]  o bp
setarPaletaProc proc near
	;coloca a base da pilha na pilha pra reservar 
	;espaco para os parametros e variveis locais
	push bp
	mov bp, sp
	pusha
	;salva o registrator si, pois ele vai ser 
	;utilizado como indice para setar a paleta
	push si
	;coloca o endereco inicial da paleta
	mov si, enderecoPaletaMemoria
	;coloca em cx a quantidade de vezes que a operacao de 
	;escrita vai se repetir (quantidade de bytes da paleta).
	;A quantidade de bytes da paleta pode ser medida atraves
	;da quantidade de cores. Se cada cor tem 3 bytes (1 byte para 
	;vermelho, um para verde e outro para azul) entao cx = 3*numeroCores
	mov cx, numeroCores
	mov ax, cx
	;ax = 2*numeroCores
	add ax, ax 
	;cx = numeroCores + ax = 3*numeroCores
	add cx, ax 
	
	;para setar a paleta, temos que enviar uma mensagem para dizer que vamos 
	;modifica-la e outras para escrever a nova paleta. As porta que se comunicam 
	;com a paleta sao as 3C8h e 3C9h
	mov dx, 3C8h
	;mensagem que vai ser enviada
	mov al, 0
	;envia a mensagem para a porta 3C8h
	out dx, al
	
	;as demais mensagens vao ser enviadas atravs de uma repeticao. O contador 
	;desta repeticao eh o registrator cx, que contm a quantidade de bytes da 
	;paleta.
	mov dx, 3C9h
	;limpa o flag de direcao para o indice da paleta poder ser incrementado
	cld
	;repete a instrucao de escrita
	rep 
	;escreve o que esta sendo apontado por si na porta contida no dx e 
	;incrementa si
	outsb
	;recupera os registradores colocados na pilha
	pop si
	popa
	pop bp
	;retorna 4 posicoes na pilha (elimina o pc e os parametros)
	ret 4
setarPaletaProc endP


;----------------------------------------------------------
; seta a posicao na tela para escrever textos
setarPosicaoTela macro posX, posY
	;salva tudo!
	pusha
	;setar o cursor
	mov ah, 02h
	mov bh, 0
	mov dh, posY
	mov dl, posX
	int 10h
	;recupera tudo!
	popa
endM
;----------------------------------------------------------
; inicializa a main e coloca o ds apontando para 
; o segmento de dados
inicializarMain macro
	;aponta ds para o segmento de dados
	mov ax, @DATA
	mov ds, ax
	mov ax, 0A000h ; endereco da memoria de video
	mov es, ax ; apontar o es para a memoria de video
endM

;----------------------------------------------------------
; seta o modo grafico e apont ao ex para a memoria de video
setarModoGrafico macro
	push ax
	mov ax, 0A000h ; endereco da memoria de video
	mov es, ax ; apontar o es para a memoria de video
	
	mov ax, 13h ; vai pro modo grafico
	int 10h
	pop ax
endM

;----------------------------------------------------------
; seta o modo texto
setarModoTexto macro
	push ax
	mov ax, 03h ; volta pro modo texto
	int 10h
	pop ax	
endM
;----------------------------------------------------------
; sai do programa
sair macro
	mov ah, 4ch ; Sair do programa
	mov al, 0
	int 21h
endM

desenharBitmap macro filename
	push di
	mov di, 0
	push filename
	call carregarArquivoProc
	pop di
endM

;----------------------------------------------------------
; procedimento para carregar um arquivo e colocar no buffer
; ex:di
nomeArquivo 	equ 4[bp]
handle		equ -2[bp]
; @param nomeArquivo Variavel onde vai estar a string com 
;o nome do arquivo
carregarArquivoProc proc near
	;salva bp na pilha
	push bp
	mov bp, sp
	;aloca variavel local handle
	add sp, -2
	;salva tudo!
	pusha
	;interrupcao para abrir arquivo para leitura
	mov ax, 3D00h
	mov dx, nomeArquivo
	int 21h
	;se bugar vai para erroAoAbrir (quando buga o CF fica setado)
	jc erroAoAbrir
	;coloca o handle na variavel local handle
	mov handle, ax
	;quantidade de bytes para ler de cada vez
	mov cx, 1
	;ponteiro para a variavel que vai ser o buffer de leitura
	mov dx, offset fileReadBuffer
	;limpa o flag de direcao
	cld
lerDenovo:
	;prepara para chamar a interrupcao de leitura de arquivo
	mov ah, 3Fh
	mov bx, handle
	int 21h
	;se bugar (se o CF estiver setado) vai para erroLeitura
	jc erroLeitura
	; compara o valor do ax que tem o numero dos bytes lidos com 1.  
	cmp ax, 1
	; se a comparacao acima for FALSE entao fimArquivo
	jne fimArquivo
	;para completar o ax
	mov ah, 0
	;colocar no al a varivel que contm o contedo do arquivo
	mov al, fileReadBuffer
	;escreve no destino o q tem no AX
	stosb
	; jump para lerDeNovo.
	jmp lerDenovo
		
erroAoAbrir: 
	setarModoTexto
	mov ah, 9
	mov dx, offset msgErroAbrirArquivo
	int 21h
	sair
erroLeitura:
	setarModoTexto
	mov ah, 9
	mov dx, offset msgErroLeituraArquivo
	int 21h
	;fecha o arquivo
	mov ah, 3Eh
	mov bx, handle
	int 21h
	sair
fimArquivo:
	;fecha o arquivo
	mov ah, 3Eh
	mov bx, handle
	int 21h
	;recupera tudo!
	popa
	;desaloca variavel local handle
	add sp, 2
	pop bp
	;faz a pilha 
	ret 2
carregarArquivoProc endP

;------------------------------------------------------------------------
;funcoes de timer
;Procedimento armazenado no IRQ0 antes de setar o timer:
;->Segmento onde estah o procedimento
procedimentoInterrupt8AntigoSegmento	dw 0
;->Offset do procedimento
procedimentoInterrupt8AntigoOffset		dw 0


;-------------------------------------------------------------
; configura o timer
setarTimer macro offsetProc, tickrate
	;guarda o conteudo dos registradores usados na macro	
	push ax
	push es
	push bx
	push ds
	push dx
	;interrupcao para pegar o procedimento que trata 
	;a interrupcao 8 (IRQ0)
	mov ax, 3508h
	int 21h
	;salva o procedimento na memoria
	mov [cs:procedimentoInterrupt8AntigoSegmento], es
	mov [cs:procedimentoInterrupt8AntigoOffset], bx
	
	;seta ds:dx como sendo o endereco do novo procedimento
	;que vai ser colocado no vetor de interrupcoes
	mov ax, @CODE
	mov ds, ax
	mov dx, offsetProc
	
	;chama a interrupcao para setar o vetor de interrupcoes
	;na posicao 8 (IRQ0)
	mov ax, 2508h
	int 21h
	
	;desabilita as interrupcoes
	cli
	;Agora depois de setar o procedimento que vai ser
	;o temporizador, configura-se a frequencia com a 
	;qual ser chamado. 
	;envia para a porta 43h (Controlador do Timer 8253)
	;as configuracoes do timer:
	;00 (Canal 0, o que controla as funcoes de timer)
	;11 (Setar primeiro o byte menos significativo,
	;	  depois o mais significativo do numero que 
	;	  representa o tickrate)
	;010 (gerador de tickrate)
	;0 (contar em binario)
	;00110100b = 34h
	mov al, 34h
	out 43h, al
	;envia primeiro o byte menos significativo do tickrate
	;para o endereco do registrator do canal 0 (40h), depois
	;o byte mais significativo.
	mov ax, 15500
	out 40h, al
	mov al, ah
	out 40h, al
	;habilita novamente as interrupcoes
	sti
	;restaura os registradores
	pop dx
	pop ds
	pop bx
	pop es
	pop ax	
endM

;-------------------------------------------------------
;restaura o timer para seu estado original

resetarTimer macro
	;guarda os registradores que vao ser usados
	push ax
	push ds
	push dx
	
	;coloca o endereco procedimento antigo no em ds:dx
	mov ds, [cs:procedimentoInterrupt8AntigoSegmento]
	mov dx, [cs:procedimentoInterrupt8AntigoOffset]
	;chama a interrupcao para setar de volta o procedimento
	mov ax, 2508h
	int 21h
	
	;desabilita as interrupcoes
	cli
	;envia para a porta do controlador de Timer a configuracao 
	;default
	mov al, 34h
	out 43h, al
	;envia primeiro o byte menos significativo do tickrate
	;para o endereco do registrator do canal 0 (40h), depois
	;o byte mais significativo.
	mov ax, 0
	out 40h, al
	mov al, ah
	out 40h, al	
	;habilita novamente as interrupcoes
	sti
	pop dx
	pop ds
	pop ax
endM


;--------------------------------------------------------
; funcao que pega a direcao do pau do teclado

setarDirecaoPau proc near
	call kbhit
	jz fimSetarDirecaoPau
	;jz parado
	call getch
	;usa a seta para cima para frear(gambiarra pesada!!)
	cmp pause, 1
	je podeDespausar
	
	cmp 	ah, 48h ;setinha cima.
   je parado
	cmp	ah, 4Bh ;setinha esquerda.
   je moveesq
   cmp	ah, 4Dh ;setinha direita.
   je	movedir
   cmp	ah, 01h ;esc.
   je	teclouesc
   cmp 	ah, 3Bh ;F1 (help) 
   je teclouHelp
podeDespausar:
   cmp 	ah, 19h ; P (Pausa)
   je teclouPause
	jmp fimSetarDirecaoPau
parado:
	mov direcaoPau, PAU_PARADO
	jmp fimSetarDirecaoPau
moveesq:
	mov direcaoPau, PAU_ESQ
	jmp fimSetarDirecaoPau
movedir:
	mov direcaoPau, PAU_DIR
	jmp fimSetarDirecaoPau
teclouesc:
	mov acabou, 1
	jmp fimSetarDirecaoPau
teclouPause:
	xor pause, 1
	jmp fimSetarDirecaoPau
teclouHelp:
	mov pause, 1
	mov help, 1
fimSetarDirecaoPau:
	ret
setarDirecaoPau endP


;----------------------------------------------------------
;funcao que espera o retraco vertical

waitRetrace proc near
	push	ax
	push	dx
	mov	dx,3DAh
l1:
	in	al, dx
	and	al, 08h
	jnz	l1
l2:
	in	al, dx
	and	al, 08h
	jz	l2
	pop	dx
	pop	ax
	ret
waitRetrace endP


;Funcao q desenha as sprites na tela
desenharSprites proc near
	pusha
	
	;Vejo se eh para desenhar o coracao na tela
	cmp coracaoEnable, 1
	je desenhaCoracao
	
comparaPocao:
	cmp pocaoEnable, 1
	je desenhaPocao
	
comparaCarinha:
	cmp carinhaEnable, 1
	je desenhaCarinha
	jmp finalDesenharr
	
desenhaCoracao:
	;Incremento a posicao Y ja q ele vai caindo
	inc coracaoPosY
	
	;Vejo se o coracao ja nao caiu de vez
	mov cx, posicaoPauY
	;Somo a posicao Y da barrinha com 2 para saber se ele ja passou da barrinha
	add cx, 2
	cmp coracaoPosY, cx
	jg naoDesenhaCoracao
	
	;Calculo a posicao
	mov bx, coracaoPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, coracaoPosX
	add ax, cx
	mov coracaoPos, ax
	
	;Coloco qual o sprite atual 
	mov dx, 0
	mov ah, 0
	mov al, spriteAtualCoracao
	;Coloco a sprite atual em ax
	mov cx, 90
	mul cx
	mov bx, ax
	mov ax, offset coracao
	add ax, bx
	
	;Mando desenhar a sprite na tela
	desenharBitmapPosicao ax, coracaoPos, spriteAltura, spriteLargura 
	;desenharBitmapPosicao ax, coracaoPos, alturaBarrinha, larguraBarrinha
	jmp comparaPocao
	
desenhaPocao:
	;Incremento a posicao Y ja q ele vai caindo
	inc pocaoPosY
	
	;Vejo se o coracao ja nao caiu de vez
	mov cx, posicaoPauY
	;Somo a posicao Y da barrinha com 2 para saber se ele ja passou da barrinha
	add cx, 2
	cmp pocaoPosY, cx
	jg naoDesenhaPocao
	
	;Calculo a posicao
	mov bx, pocaoPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, pocaoPosX
	add ax, cx
	mov pocaoPos, ax
	
	;Coloco qual o sprite atual 
	mov dx, 0
	mov ah, 0
	mov al, spriteAtualPocao
	;Coloco a sprite atual em ax
	mov cx, 90
	mul cx
	mov bx, ax
	mov ax, offset pocao
	add ax, bx
	
	;Mando desenhar a sprite na tela
	desenharBitmapPosicao ax, pocaoPos, spriteAltura, spriteLargura 
	;desenharBitmapPosicao ax, coracaoPos, alturaBarrinha, larguraBarrinha
	jmp comparaCarinha
	
desenhaCarinha:
	;Incremento a posicao Y ja q ele vai caindo
	inc carinhaPosY
	
	;Vejo se o coracao ja nao caiu de vez
	mov cx, posicaoPauY
	;Somo a posicao Y da barrinha com 2 para saber se ele ja passou da barrinha
	add cx, 2
	cmp carinhaPosY, cx
	jg naoDesenhaCarinha
	
	;Calculo a posicao
	mov bx, carinhaPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, carinhaPosX
	add ax, cx
	mov carinhaPos, ax
	
	;Coloco qual o sprite atual 
	mov dx, 0
	mov ah, 0
	mov al, spriteAtualCarinha
	;Coloco a sprite atual em ax
	mov cx, 90
	mul cx
	mov bx, ax
	mov ax, offset carinha
	add ax, bx
	
	;Mando desenhar a sprite na tela
	desenharBitmapPosicao ax, carinhaPos, spriteAltura, spriteLargura 
	;desenharBitmapPosicao ax, coracaoPos, alturaBarrinha, larguraBarrinha
	jmp finalDesenharr

naoDesenhaCoracao:
	;Seto q eh para apagar o coracao
	mov coracaoEnable, 0
	jmp finalDesenharr
	
naoDesenhaPocao:
	;Seto q eh para apagar o coracao
	mov pocaoEnable, 0
	jmp finalDesenharr

naoDesenhaCarinha:
	;Seto q eh para apagar o coracao
	mov carinhaEnable, 0

finalDesenharr:
	popa
	ret
desenharSprites endP


;----------------------------------------------------------
;Procedimento que vai servir de temporizador do jogo
timerProc proc far
	pushf
	push	ds
	pusha
	push	es
	mov	ax, @DATA
	mov	ds, ax
	mov ax, 0A000h ; endereco da memoria de video
	mov es, ax ; apontar o es para a memoria de video

	call setarDirecaoPau
	
	cmp pause, 1
	je fimPause
	
	call waitRetrace
	call desenharFundo
	call desenharBoxs
	call desenharPau
	call desenharBolinha
	call verificaColisaoBox
	call desenharPontos
	;Chamo a funcao de animar os sprites
	call animar
	;Chamo a funcao de desenhar as sprites na tela
	call desenharSprites
	;Chamo a funo de ver se o coracao bateu na barrinha
	call verificaColisaoCoracao
	call verificaColisaoPocao
	call verificaColisaoCarinha
fimPause:
 	;diz que acabou o procedimento
 	mov dx, 20h
   mov al, 20h
   out dx, al 
	
	pop es
	popa
	pop ds
   popf
	iret
timerProc endP
	

;---------------------------------------------------------
;Procedimento que desenha os pontos na tela

desenharPontos proc near
	pusha
	
	;Pontos!
	;desenharString dx, 68, 2, 8, 60
	;Movo paa dx a variavel q contem a string "Pontos: "
	mov dx, offset lblPontos
	push dx
	push word ptr 67
	push word ptr 7
	push word ptr 6 ;amarelo
	push word ptr 1
	call desenharStringProc
	
	push pontos
	call itoa
	mov dx, offset itoaReturn
	
	;Pontos!
	;desenharString dx, 68, 2, 8, 60
	push dx
	push word ptr 74
	push word ptr 7
	push word ptr 2
	push word ptr 1
	call desenharStringProc
	
	;Pontos!
	;desenharString dx, 68, 2, 8, 60
	;Movo paa dx a variavel q contem a string "Pontos: "
	mov dx, offset lblVidas
	push dx
	push word ptr 67
	push word ptr 9
	push word ptr 239 ;rosa
	push word ptr 1
	call desenharStringProc
	
	
	;Tranforma em string
	push vidas
	call itoa
	mov dx, offset itoaReturn
	
	;Vidas!
	;desenharString o q quero escrever, posX, posY, forecolour, backcolor
	push dx
	push word ptr 74
	push word ptr 9
	push word ptr 2
	push word ptr 1
	call desenharStringProc
	
	;mov ah, 0
	;mov al, numeroQuadrados
	;push ax
	;call itoa
	
	;Numero de quadrado
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	;push dx
	;push word ptr 68
	;push word ptr 4
	;push word ptr 8
	;push word ptr 159
	;call desenharStringProc
	mov dx, offset lblEstagio
	push dx
	push word ptr 67
	push word ptr 11
	push word ptr 107 ;verde
	push word ptr 1
	call desenharStringProc
	
	mov ah, 0
	mov al, numeroEstagios
	push ax
	call itoa
	
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	mov dx, offset itoaReturn
	push dx
	push word ptr 74
	push word ptr 11
	push word ptr 2
	push word ptr 1
	call desenharStringProc
	
	
	;the one!!
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	mov dx, offset lblHiScore
	push dx
	push word ptr 67
	push word ptr 13
	push word ptr 33 ;roxo
	push word ptr 1
	call desenharStringProc
	
	
	mov ax, ultimoScore
	push ax
	call itoa
	
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	mov dx, offset itoaReturn
	push dx
	push word ptr 74
	push word ptr 13
	push word ptr 2
	push word ptr 1
	call desenharStringProc
	
	;cmp passaLotado, 1
	;jne fimProcDP
	;mov ah, 0
	;mov al, timerPocao
	;push ax
	;call itoa
	
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	;mov dx, offset itoaReturn
	;push dx
	;push word ptr 74
	;push word ptr 11
	;push word ptr 8
	;push word ptr 159
	;call desenharStringProc
	
;--------------------------------------------------------
	;Vejo se a direcao X eh negativa
	;cmp vetorDirecaoBolinhaX, 0
	;mov ax, vetorDirecaoBolinhaX
	;js vetorNegativoX
	;push ax
	;call itoa

	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
	;push dx
	;push word ptr 68
	;push word ptr 6
	;push word ptr 8
	;push word ptr 159
	;call desenharStringProc
	;jmp testarVetorY
	
;Para nao aparecer o numero complementado a 2
;vetorNegativoX:
;	neg ax
;
;	push ax
;	call itoa
;	;Para eu mandar aparecer o sinal de negativo no numero
;	mov bx, 0
;	mov itoaReturn[bx], '-'
;	
;	;desenharString dx, 68, 2, 8, 60
;	;ainda tah trash mas funciona :)
;	push dx
;	push word ptr 68
;	push word ptr 6
;	push word ptr 8
;	push word ptr 159
;	call desenharStringProc
;	
;;-----------------------------------------------------------	
;testarVetorY:
;
;	;Vejo se a direcao X eh negativa
;	cmp vetorDirecaoBolinhaY, 0
;	mov ax, vetorDirecaoBolinhaY
;	js vetorNegativoY
;	push ax
;	call itoa
;	
;	;desenharString dx, 68, 2, 8, 60
;	;ainda tah trash mas funciona :)
;	push dx
;	push word ptr 68
;	push word ptr 7
;	push word ptr 8
;	push word ptr 159
;	call desenharStringProc
;	jmp fimProcTestar
;	
;;Para nao aparecer o numero complementado a 2
;vetorNegativoY:
;	neg ax
;
;	push ax
;	call itoa
;	;Para eu mandar aparecer o sinal de negativo no numero
;	mov bx, 0
;	mov itoaReturn[bx], '-'
;
;	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
;	push dx
;	push word ptr 68
;	push word ptr 7
;	push word ptr 8
;	push word ptr 159
;	call desenharStringProc
;	
;;---------------------------------------------------------------
;fimProcTestar:
;	mov ah, 0
;	mov al, spriteAtualCoracao
;	push ax
;	call itoa
;
	;desenharString dx, 68, 2, 8, 60
	;ainda tah trash mas funciona :)
;	push dx
;	push word ptr 68
;	push word ptr 8
;	push word ptr 8
;	push word ptr 159
;	call desenharStringProc
fimProcDP:
	popa
	ret
desenharPontos endP
	
;---------------------------------------------------------
;verifica se o teclado foi pressionado, se foi pressionado
;ZF = 0
kbhit proc near
	mov ah, 1
	int 16h	
	ret
kbhit endP
;---------------------------------------------------------
;pega um caractere do teclado e armazena o "scan code" 
;no registrador ah
getch proc near
	mov ah, 0
	int 16h	
	ret
getch endP

;---------------------------------------------------------
; Funo que escreve a pontuao do cara no arquivo	
; @param nome o nome do jogador
; @param tamanhoNome tamanho da varivel q guarda o nome do jogador para quando 
; for escrever no arquivo
escreverPontosArquivo macro nomeJogador, tamanhoNome
	push nomeJogador
	push tamanhoNome
	call escreverArquivoProc
endM

;-------------------------------------------------------------------
;Escreve num arquivo
;@param nomeArquivoEA nome do arquivo a ser escrito
nomeArquivoEA 	equ  4[bp]
; variaveis locais:
handleEscrever equ -2[bp]
escreverArquivoProc proc near
	push bp
	mov bp, sp
	add sp, -2
	pusha
	;interrupcao para abrir arquivo para escrita
	mov ah, 3Dh
	mov al, 1
	mov dx, nomeArquivoEA
	int 21h
	;se bugar vai para erroAoAbrir (quando buga o CF fica setado)
	jc erroAoAbrirEA
escreverProc:
	;coloca o handle na variavel local handle
	mov handleEscrever, ax
	;quantidade de bytes para escrever de cada vez
	mov cx, 2
	;ponteiro para a variavel que vai ser o buffer de leitura
	mov dx, offset pontos
	;limpa o flag de direcao
	mov ah, 40h
	mov bx, handleEscrever
	int 21h
	;se bugar (se o CF estiver setado) vai para erroLeitura
	jc erroEscrita
	; compara o valor do ax que tem o numero dos bytes lidos com 1.  
	cmp ax, 2
	; se a comparacao acima for FALSE entao fimArquivo
	je fimArquivoEA
	jmp erroEscrita
erroAoAbrirEA:
	setarModoTexto
	mov ah, 9
	mov dx, offset msgErroAbrirArquivo
	int 21h
	sair
erroEscrita:
	setarModoTexto
	mov ah, 9
	mov dx, offset msgErroLeituraArquivo
	int 21h
	sair
fimArquivoEA:
	;recupera tudo!
	mov ah, 3Eh
	mov bx, handleEscrever
	int 21h
	popa
	;desaloca variavel local handle
	add sp, 2
	pop bp
	;faz a pilha 
	ret 2
escreverArquivoProc endP

;---------------------------------------------------------	
;Procedimentos paa desenhar na tela



;---------------------------------------------------------
;Macro para desenhar um quadrado na tela
desenharQuadrado macro posicaoTela, altura, largura, cor
	push posicaoTela
	push altura
	push largura
	push cor
	call desenharQuadradoProc
endM

;---------------------------------------------------------
;Procedimento para desenhar um quadrado na tela
;@param posicaoTelaDQ posicao (linear) que o quadrado vai 
;							 ser desenhado na tela (320x200)
posicaoTelaDQ	equ 10[bp]
;@param alturaDQ altura do quadrado
alturaDQ			equ  8[bp]
;@param larguraDQ largura do quadrado
larguraDQ		equ  6[bp]
;@param corDQ cor do quadrado
corDQ				equ  4[bp]
;---------------------------------------------------------
;variaveis locais
linhaAtualDQ 		equ -2[bp]
ultimoPixelDQ		equ -4[bp]
desenharQuadradoProc proc near
	push bp
	mov bp, sp
	add sp, -4
	;coloca todos na pilha.
	pusha
	;guarda o di
	push di
	;inicializa a linha atual com a posicao linear atual
	;do quadrado
	mov ax, posicaoTelaDQ
	mov linhaAtualDQ, ax
	;calcula o endereco do ultimo pixel = (primeiro pixel) + (altura*largura)
	mov ax, posicaoTelaDQ
	mov ultimoPixelDQ, ax
	;coloco em ax a altura do bitmap e em bx a largura para poder multiplicar
	;pois a sintaxe de mul eh pegar o q tem em ax multiplicar com o parametro e jogar em ax
	mov ax, alturaDQ
	mov bx, larguraDQ
	mul bx 
	;adiciono o resultado da multiplicacao com o comeco do quadrado para saber o pixel final
	add ultimoPixelDQ, ax
	;limpa o flag de direo 
	cld	
	;coloco em di que eh o contador de linha
	mov di, linhaAtualDQ
	
	;coloca em bx o ultimo pixel do quadrado para saber quando o quadrado acabou
	;mov bx, ultimoPixelDQ
	mov bx, 0
	mov ax, corDQ
	;label q da o loop na linha
	loopLinhaDQ: 
		mov cx, larguraDQ
		rep stosb		
		;vai para a proxima linha na tela (soma com 320 = 140h)
		add linhaAtualDQ, word ptr 140h 
		mov di, linhaAtualDQ
		inc bx
		;compara o pixel atual com o pixel final
		cmp bx, alturaDQ
		je fimQuadrado
		jmp loopLinhaDQ
		
	fimQuadrado:
		pop di
		popa
		add sp, 4
		pop bp
		ret 8	
desenharQuadradoProc endP


;Verifica a coliso do coraozinho com a barrinha
verificaColisaoCoracao proc near
	pusha
	
	;Vejo se o coracao tah enable se tiver continua, se nao vou pro final
	cmp coracaoEnable, 0
	je fimVerCC
	
	;verifica se a bolinha bateu no pau
	mov ax, coracaoPosY
	add ax, spriteAltura ;altura da bolinha
	cmp ax, posicaoPauY
	jge verificaBateuC
	
	jmp fimVerCC
	
verificaBateuC:
	;verifica se estah na superficie do pau
	mov ax, posicaoPauX
	cmp coracaoPosX, ax
	jl fimVerCC
	add ax, larguraBarrinha
	cmp coracaoPosX, ax
	jge fimVerCC
	;Incremento o numero de vidas, pois o coracao bateu na barrinha
	inc vidas
	;Adiciono 50 pontos pq ele pegou o coracao
	add pontos, 50
	;Digo q o coracao na vai aparecer mais
	mov coracaoEnable, 0
	;Mando apagar
	mov al, corFundo
	mov ah, 0
	desenharQuadrado coracaoPos, spriteAltura, spriteLargura, ax
	
fimVerCC:
	popa
	ret
verificaColisaoCoracao endP

;Verifica a coliso da pocao com a barrinha
verificaColisaoPocao proc near
	pusha
	
	;Vejo se o coracao tah enable se tiver continua, se nao vou pro final
	cmp pocaoEnable, 0
	je fimVerP
	
	;verifica se a bolinha bateu no pau
	mov ax, pocaoPosY
	add ax, spriteAltura ;altura da bolinha
	cmp ax, posicaoPauY
	jge verificaBateuP
	
	jmp fimVerP
	
verificaBateuP:
	;verifica se estah na superficie do pau
	mov ax, posicaoPauX
	cmp pocaoPosX, ax
	jl fimVerP
	add ax, larguraBarrinha
	cmp pocaoPosX, ax
	jge fimVerP
	;---------------------------------------------
	;
	mov passaLotado, 1	
	mov timerPocao, 150
		
	;---------------------------------------------
	;Digo q o coracao na vai aparecer mais
	mov pocaoEnable, 0
	;Mando apagar
	;Adiciono 50 pontos pq ele pegou o coracao
	add pontos, 50
	mov al, corFundo
	mov ah, 0
	desenharQuadrado pocaoPos, spriteAltura, spriteLargura, ax
	
fimVerP:
	popa
	ret
verificaColisaoPocao endP

;Verifica a coliso da pocao com a barrinha
verificaColisaoCarinha proc near
	pusha
	
	;Vejo se o coracao tah enable se tiver continua, se nao vou pro final
	cmp carinhaEnable, 0
	je fimVerCara
	
	;verifica se a bolinha bateu no pau
	mov ax, carinhaPosY
	add ax, spriteAltura ;altura da bolinha
	cmp ax, posicaoPauY
	jge verificaBateuCara
	
	jmp fimVerCara
	
verificaBateuCara:
	;verifica se estah na superficie do pau
	mov ax, posicaoPauX
	cmp carinhaPosX, ax
	jl fimVerCara
	add ax, larguraBarrinha
	cmp carinhaPosX, ax
	jge fimVerCara
	
	;Digo q a carinha na vai aparecer mais
	mov carinhaEnable, 0
	;Incremento os pontos do cara
	add pontos, 250
	;Mando apagar
	mov al, corFundo
	mov ah, 0
	desenharQuadrado carinhaPos, spriteAltura, spriteLargura, ax
	
fimVerCara:
	popa
	ret
verificaColisaoCarinha endP


;---------------------------------------------------------
;redesenha o fundo da tela para nao deixar o ny7 dos 
;elementos desenhados
desenharFundo proc near
	push ax
	;zera ax
	xor ax, ax
	;coloca em ax a cor do fundo para apagar o rastro do pau 
	mov al, corFundo
	;apaga o rastro do pau
	desenharQuadrado posicaoPau, alturaBarrinha, larguraBarrinha, ax
	;apaga rastro da bolinha
	desenharQuadrado posicaoBolinha, alturaBolinha, larguraBolinha, ax
	
	;Apago onde a sprite do coracao estava
	cmp coracaoEnable, 0
	je desenhaFundoCarinha
	desenharQuadrado coracaoPos, spriteAltura, spriteLargura, ax

desenhaFundoCarinha:
	;Apago onde a sprite do coracao estava
	cmp carinhaEnable, 0
	je desenhaFundoPocao
	desenharQuadrado carinhaPos, spriteAltura, spriteLargura, ax


desenhaFundoPocao:
	cmp pocaoEnable, 0
	je fimDesenharFundo
	desenharQuadrado pocaoPos, spriteAltura, spriteLargura, ax
	
fimDesenharFundo:
	pop ax
	ret
desenharFundo endP
;---------------------------------------------------------
;calcula a posicao do pau e o desenha na tela
desenharPau proc near
	push ax
	push cx
	;ve qual eh a direcao do pau
	cmp direcaoPau, PAU_DIR
	je direita
	cmp direcaoPau, PAU_ESQ
	je esquerda
	cmp direcaoPau, PAU_PARADO
	je desenha

;move o pau para a direita
direita:
	;se o pau jah estiver no canto da tela, nao move
	mov ax, posicaoPauX
	mov cx, fimTela
	sub cx, larguraBarrinha
	cmp ax, cx
	jge desenha
	
	add posicaoPau, 4
	add posicaoPauX, 4
	;Se mecheu o pauzinho eu seto q a bolinha nao tah + parada
	;no caso do inicio do jogo
	mov bolinhaParada, 0
	
	jmp desenha

;move o pau para a esquerda
esquerda:
	;se o pau jah estiver no canto da tela, nao move
	mov ax, posicaoPauX
	;para nao engolir o lado esquerdo da tela...
	sub ax, 2
	cmp ax, comecoTela
	jle desenha
	
	sub posicaoPau, 4
	sub posicaoPauX, 4
	;Se mecheu o pauzinho eu seto q a bolinha nao tah + parada
	;no caso do inicio do jogo
	mov bolinhaParada, 0
	
	jmp desenha
	
;desenha o pau
desenha:
	mov ax, offset pau
	desenharBitmapPosicao ax, posicaoPau, alturaBarrinha, larguraBarrinha	
	pop cx
	pop ax
	ret
desenharPau endP
;---------------------------------------------------------
;calcula a posicao da bolinha e desenha na tela
desenharBolinha proc near
	pusha
	
	;Vejo se a bolinha esta parada, se estiver eu mando desenhar ela sem mexer
	;isso no caso do incio do jogo
	cmp bolinhaParada, 1
	je desenhaBolinhaTela
	
	;atualiza a posicao da bolinha de acordo com o vetor
	mov ax, posicaoBolinhaX
	add ax, vetorDirecaoBolinhaX
	mov posicaoBolinhaX, ax
	
	mov ax, posicaoBolinhaY
	add ax, vetorDirecaoBolinhaY
	mov posicaoBolinhaY, ax
	
	;calcula a posicao linear da bolinha de acordo com as posicoes X e Y
	;calcularPosicao posicaoBolinhaX, posicaoBolinhaY
	;--------------------------------
	mov bx, posicaoBolinhaY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, posicaoBolinhaX
	add ax, cx
	mov posicaoBolinha, ax
	
	;ve se a bolinha bateu nas paredes
	mov ax, comecoTela
	inc ax
	cmp posicaoBolinhaX, ax
	jle trocaX
	mov ax, fimTela
	sub ax, larguraBolinha
	cmp posicaoBolinhaX, ax
	jge trocaX
	mov ax, comecoTela
	inc ax
	cmp posicaoBolinhaY, ax
	jle testaY

	;Vejo se ele passou da posicao da barrinha e no bateu
	;nela  porque ele perdeu!
	mov ax, posicaoPauY
	add ax, 2 ;??
	cmp posicaoBolinhaY, ax
	jge morreu
	
	;verifica se a bolinha bateu no pau
	mov ax, posicaoBolinhaY
	add ax, alturaBolinha ;altura da bolinha
	cmp ax, posicaoPauY
	jge verificaBateuPau
	
	jmp desenhaBolinhaTela
	
verificaBateuPau:
	;verifica se estah na superficie do pau
	mov ax, posicaoPauX
	cmp posicaoBolinhaX, ax
	jl desenhaBolinhaTela
	add ax, larguraBarrinha
	cmp posicaoBolinhaX, ax
	jge desenhaBolinhaTela
	;Vejo se ela entrou so um pixel a mais, pois como a bolinha anda de 2 em 
	;2 pixels se ela passou + de 1 pixel eh porque ela ja perdeu
	mov ax, posicaoBolinhaY
	add ax, alturaBolinha
	sub ax, posicaoPauY
	cmp ax, 1
	jg desenhaBolinhaTela
	
	;-------------------------------
	inc pontos
	;-------------------------------
	mov ax, posicaoPauX
	add ax, 16 ; fim da primeira parte do pau
	cmp posicaoBolinhaX, ax
	jl ricochete2y
	add ax, 16 ; fim da segunda parte do pau
	cmp posicaoBolinhaX, ax
	jl ricochete
	add ax, 17 ; fim da terceira parte do pau
	cmp posicaoBolinhaX, ax
	jle ricochete2x
	;-------------------------------
ricochete2y:
	mov vetorDirecaoBolinhaY, 1
	jmp trocaY
ricochete:
	cmp vetorDirecaoBolinhaY, 0 ;verifica o sinal
	jns ricocheteS
	mov vetorDirecaoBolinhaY, -2
	jmp trocaY
ricocheteS:
	mov vetorDirecaoBolinhaY, 2
	jmp trocaY
ricochete2x:
	cmp vetorDirecaoBolinhaX, 0 ;verifica o sinal
	jns ricochete2xS
	mov vetorDirecaoBolinhaX, -1
	jmp trocaY
ricochete2xS:
	mov vetorDirecaoBolinhaX, 1
	jmp trocaY

testaY:
	; Se bateu na parede de cima entao eu mudo a direcao Y e mando incrementar de 1 a posicao para ele nao bater mais
	neg vetorDirecaoBolinhaY
	inc posicaoBolinhaY
	jmp desenhaBolinhaTela

trocaX:
	neg vetorDirecaoBolinhaX
	jmp desenhaBolinhaTela
	
trocaY:
	neg vetorDirecaoBolinhaY
	;---------------------------------
desenhaBolinhaTela:
	mov dx, offset bolinha
	desenharBitmapPosicao dx, posicaoBolinha, alturaBolinha, larguraBolinha 
	jmp fimDB
	;mov ax, 3
	;desenharQuadrado posicaoBolinha, alturaBolinha, larguraBolinha, ax 
morreu:
	cmp vidas, 0
	je acabouJogo
	jmp naoAcabouJogo
acabouJogo:
	mov acabou, 1
	jmp fimDB
naoAcabouJogo:
	dec vidas
	;Se mecheu o pauzinho eu seto q a bolinha nao tah + parada
	;no caso do inicio do jogo
	mov bolinhaParada, 1
	;tira o poder da bolinha se ela tiver pego a pocao
	mov passaLotado, 0
	desenharQuadrado posicaoPau, alturaBarrinha,larguraBarrinha, 185
	
	;Coloco a barrinha e a bolinah na sua posio inicial
	mov posicaoPauX, posicaoBarrinhaXInicial
	mov posicaoPauY, posicaoBarrinhaYInicial
	mov posicaoPau, posicaoBarrinhaInicial
	mov direcaoPau, PAU_PARADO

	mov posicaoBolinhaX, posicaoBolinhaXInicial
	mov posicaoBolinhaY, posicaoBolinhaYInicial
	mov posicaoBolinha, posicaoBolinhaInicial
	mov vetorDirecaoBolinhaX, -2
	mov vetorDirecaoBolinhaY, -2
	
fimDB:
	popa
	ret
desenharBolinha endP

calcularPosicao macro posicaoX, posicaoY
	pusha 
	mov bx, posicaoY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal bx, 6
	mov ax, bx
	sal bx, 2
	add ax, bx
	;soma a coluna
	mov cx, posicaoX
	add ax, cx
	mov posicaoBolinha, ax
	popa
endM


;---------------------------------------------------------
;procedimento que coloca os boxs na tela
desenharBoxs proc near
	pusha
	;coloca cx apontando para o endereco dos boxs na tela
	mov ax, inicioBoxsY
	mov bx, 320
	mul bx; ax = ax*320
	mov cx, ax ; posicao inicial dos boxs
	add cx, inicioBoxsX ; posicao inicial dos boxs
	mov dx, cx ;linha atual
	mov si, 0; contador de boxs
	xor bx, bx
	xor ax, ax
loopBox:
	mov al, boxs[bx]
	cmp al, 0
	jnz desenhaBox
	
	desenharQuadrado cx, alturaBox, larguraBox, 185 ; box 10x10 cor do fundo na posicao cx
	
	jmp fimLoopBox
desenhaBox:
	;desenharQuadrado cx, alturaBox, larguraBox, 3 ; box 10x10 cor 3(preto) na posicao cx
	cmp al, 01
	je desenhaBloco1
	cmp al, 02
	je desenhaBloco2
	cmp al, 03
	je desenhaBloco3
	cmp al, 04
	jge desenhaBlocoEspecial
	desenhaBloco1:
		mov di, offset bloco1
		desenharBitmapPosicao di, cx, alturaBox, larguraBox
		jmp fimLoopBox
	desenhaBloco2:
		mov di, offset bloco2
		desenharBitmapPosicao di, cx, alturaBox, larguraBox
		jmp fimLoopBox
	desenhaBloco3:
		mov di, offset bloco3
		desenharBitmapPosicao di, cx, alturaBox, larguraBox
		jmp fimLoopBox
	desenhaBlocoEspecial:
		mov di, offset blocoEspecial
		desenharBitmapPosicao di, cx, alturaBox, larguraBox
fimLoopBox:
	inc si
	inc bx
	cmp bx, size boxs ;numero de bytes da variavel "boxs"
	je fimDesenharBoxs
	cmp si, boxsPorLinha ;numero de boxs por linha
	je pulaLinhaBox
	add cx, larguraBox ;largura do box + separacao horizontal do proximo box
	add cx, separacaoBoxsX ;largura do box + separacao horizontal do proximo box
	jmp loopBox
pulaLinhaBox:
	mov ax, alturaBox
	add ax, separacaoBoxsY
	mov di, 320
	push dx ; dx tem que ser 0 quando vai multipicar senao o bixo endoida
	mov dx, 0
	;multiplica ax por di
	mul di
	pop dx ; agora recupera dx!
	add dx, ax ;(altura do box + separacao vertical do proximo box)*320
	mov cx, dx ; atualiza cx com a posicao dos proximo box
	mov si, 0
	jmp loopBox
fimDesenharBoxs:
	popa
	ret
desenharBoxs endP

;---------------------------------------------------------
; Verifica a colisao da bolinha com os boxs
contadorVCB equ -2[bp]
tempX			equ -4[bp]
tempY			equ -6[bp]
posRelBoxX  equ -8[bp]
posRelBoxY  equ -10[bp]

verificaColisaoBox proc near
	push bp
	mov bp, sp
	add sp, -10
	pusha
	mov contadorVCB, word ptr 0
verificaCorner:
	mov dx, posicaoBolinhaX
	mov ax, posicaoBolinhaY
	mov tempX, dx
	mov tempY, ax
	
	cmp contadorVCB, word ptr 0
	je pontoEC
	cmp contadorVCB, word ptr 1
	je pontoDC
	cmp contadorVCB, word ptr 2
	je pontoEB
	cmp contadorVCB, word ptr 3
	je pontoDB
	cmp contadorVCB, word ptr 4
	je naoColidiu
pontoEC:
	jmp calculaColisao
pontoEB:
	add tempY, alturaBolinha
	jmp calculaColisao
pontoDC:
	add tempX, larguraBolinha
	jmp calculaColisao
pontoDB:
	add tempX, larguraBolinha
	add tempY, alturaBolinha

calculaColisao:
	;ve se estah na area dos boxs
	;(se estah dentro do retangulo ((inicioBoxsX, inicioBoxsY), (122, 30)))
	mov dx, inicioBoxsX
	cmp tempX, dx
	jl naoColidiuVolta
	cmp tempX, word ptr 190 ;trocar por ((larguraBox + separacaoX)*boxsPorLinha)+inicioBoxsX
	jg naoColidiuVolta
	mov dx, inicioBoxsY
	cmp tempY, dx
	jl naoColidiuVolta
	;108 sao 7 linhas
	cmp tempY, word ptr 108 ; trocar por ((alturaBox + separacaoY)*((size boxs)/boxsPorLinha))+inicioBoxsY
	jg naoColidiuVolta
	;estah na area dos boxs:
	;---------------------------
	mov ax, tempX
	sub ax, inicioBoxsX
	mov cx, larguraBox
	add cx, separacaoBoxsX
	mov dx, 0 ;para dividir
	div cx
	;guardo a posicao X da bolinah em relacao ao box
	mov posRelBoxX, dx
	cmp dx, larguraBox
	jg naoColidiuVolta
	mov bx, ax
	
	mov ax, tempY
	sub ax, inicioBoxsY
	mov cx, alturaBox
	add cx, separacaoBoxsY
	mov dx, 0 ;para dividir
	div cx
	;guardo a posicao Y da bolinah em relacao ao box
	mov posRelBoxY, dx
	cmp dx, alturaBox
	jg naoColidiuVolta
	mov dx, boxsPorLinha
	mul dx
	add bx, ax
	;tem algum box no lugar?
	cmp boxs[bx], 0
	je naoColidiuVolta
	;---------------------------
	;colidiu!!
	;codigo para imprimir o indice do array de boxs:
	;push bx
	;call itoa
	;mov dx, offset itoaReturn
	;push dx
	;push word ptr 60
	;push word ptr 20
	;push word ptr 3
	;push word ptr 60
	;-->desenharString dx, 60, 20, 3, 60 
	;call desenharStringProc
	cmp bx, size boxs
	jge naoColidiuVolta
	
	;-----------------------------------------
	cmp passaLotado, 1
	je apagaBloco
	;-----------------------------------------
	
	;J colidiu ento mando para jaColidiu para verificar
	; a nova direo da bolinha
	cmp vetorDirecaoBolinhaX, 0
	;Se x for negativo entao eu pulo para verificar se o y eh negativo
	js X_neg
	;Se chegou aqui eh porque nao saltou e o x eh positivo, entao eu mando para x_pos
	jmp X_pos
	
X_neg:
	cmp vetorDirecaoBolinhaY, 0
	js X_neg_Y_neg
	;Se chegou aqui ento  porque o X eh negativo e o Y eh positivo, ai eu vejo
	;se ele bateu nas paredes 1 ou 2 de acordo com o desenho do quadrado abaixo:
	;   ___1__
	;  |      |
	; 3|      | 2
	;  |__4___|
	jmp X_neg_Y_pos

X_pos:
	cmp vetorDirecaoBolinhaY, 0
	js X_pos_Y_neg
	;Se nao eh porque eh X positivo e Y positivo
	jmp X_pos_Y_pos
			
;Se entrou aqui ento eu verifico se bateu nas paredes 2 ou 3
X_neg_Y_neg:
	;Vejo para qual parede a distncia  menor, se for igual  porque
	; eu bati na quina do quadrado e eu mando rebater para onde veio
	;Como eu tenho a distancia X da parede 4 para eu ver a para a parede 2 eu pego
	;a largura do box e subtraio da posicaoRelativaX
	mov ax, larguraBox
	sub ax, posRelBoxX  ; parede 2
	mov cx, alturaBox
	sub cx, posRelBoxY  ; parede 3
	cmp ax, cx
	je bateuQuina
	jg bateu_horizontal
	jmp bateu_vertical
	
;Se entrou aqui ento eu verifico se bateu nas paredes 1 ou 2
X_neg_Y_pos:
	mov ax, larguraBox
	sub ax, posRelBoxX  ; parede 2
	cmp ax, posRelBoxY ; parede 1
	je bateuQuina
	jg bateu_horizontal
	jmp bateu_vertical

;Se entrou aqui ento eu verifico se bateu nas paredes 1 ou 4
X_pos_Y_pos:
	mov ax, posRelBoxX ; parede 4
	cmp ax, posRelBoxY ; parede 1
	je bateuQuina
	jg bateu_horizontal
	jmp bateu_vertical

;Se entrou aqui ento eu verifico se bateu nas paredes 3 ou 4
X_pos_Y_neg:
	mov ax, alturaBox
	sub ax, posRelBoxY  ; parede 3
	cmp ax, posRelBoxX  ; parede 4
	je bateuQuina
	jg bateu_vertical
	jmp bateu_horizontal

bateu_horizontal: 
	;Se bateu na horizontal eu inverto a direo Y
	neg vetorDirecaoBolinhaY
	;Jump para ir para apagar o bloquinho
	jmp apagaBloco

bateu_vertical:
	;Se bateu na vertical entao eu inverto o X
	neg vetorDirecaoBolinhaX
	;Jump para ir para apagar o bloquinho
	jmp apagaBloco
	
bateuQuina:
	;Se bateu na quina eu volto de onde eu vim
	neg vetorDirecaoBolinhaX
	neg vetorDirecaoBolinhaY
	;Jump para ir para apagar o bloquinho
	jmp apagaBloco

apagaBloco:
	;Vejo se nao eh um bloco especial se for um bloco especial eu mando cair o q ele guarda
	; e apago ele
	cmp boxs[bx], numeroEspecial
	jge apagaBlocoEspecial
	
	dec boxs[bx]
	add pontos, 10
	jmp continuaFuncaoA
	
apagaBlocoEspecial:
	;Vejo qual o quadrado e dependendo eu solto as coisinhas
	cmp boxs[bx], 4 ;Se for coracao
	je ehCoracao
	cmp boxs[bx], 5 ;Se for pocao
	je ehPocao
	cmp boxs[bx], 6 ;Se for carinha
	je ehCarinha
	
ehCoracao:
	;Mando saltar o coracaozinho
	;Seto a posicao Inicial do coracaozinho
	mov ax, posicaoBolinhaX
	mov coracaoPosX, ax
	mov ax, posicaoBolinhaY
	mov coracaoPosY, ax
	
	;Calculo a posicao
	mov cx, coracaoPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal cx, 6
	mov ax, cx
	sal cx, 2
	add ax, cx
	;soma a coluna
	mov dx, coracaoPosX
	add ax, dx
	mov coracaoPos, ax
	
	;Seto para baixar o coracaozinho
	mov coracaoEnable, 1
		
	;apago o quadradoEspecial
	mov boxs[bx], 0
	jmp continuaFuncaoA

ehPocao:
	;Mando saltar a pocao
	mov ax, posicaoBolinhaX
	mov pocaoPosX, ax
	mov ax, posicaoBolinhaY
	mov pocaoPosY, ax
	
	;Calculo a posicao
	mov cx, pocaoPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal cx, 6
	mov ax, cx
	sal cx, 2
	add ax, cx
	;soma a coluna
	mov dx, pocaoPosX
	add ax, dx
	mov pocaoPos, ax
	
	;Seto para baixar o coracaozinho
	mov pocaoEnable, 1
	;apago o quadradoEspecial
	mov boxs[bx], 0
	jmp continuaFuncaoA

ehCarinha:

	;Mando saltar o coracaozinho
	;Seto a posicao Inicial do coracaozinho
	mov ax, posicaoBolinhaX
	mov carinhaPosX, ax
	mov ax, posicaoBolinhaY
	mov carinhaPosY, ax
	
	;Calculo a posicao
	mov cx, carinhaPosY
	; o endereco que vou escrever eh: (y*320) + x
	; y*320 = y*256 + y*64
	sal cx, 6
	mov ax, cx
	sal cx, 2
	add ax, cx
	;soma a coluna
	mov dx, carinhaPosX
	add ax, dx
	mov carinhaPos, ax
	
	;Seto para baixar o coracaozinho
	mov carinhaEnable, 1
		
	;apago o quadradoEspecial
	mov boxs[bx], 0
	jmp continuaFuncaoA
	
continuaFuncaoA:
	;V se o quadrado foi apagado e ai decrementa o contador de
	;quadrados ativos
	mov al, boxs[bx]
	cmp al, 0h
	jne naoColidiu
	;Para saltar para o final da funo
	dec numeroQuadrados
	jmp naoColidiu
	;---------------------------	
naoColidiuVolta:
	inc word ptr contadorVCB
	jmp verificaCorner

naoColidiu:
	cmp numeroQuadrados, 0
	jne fimColisao
	;Se acabaram os quadrados o estagio acabou, ai eu mando resetar
	;a posicao da bolinha e da barrinha
	;Voltar a posicao da bolinha e da barrinha
	;Se mecheu o pauzinho eu seto q a bolinha nao tah + parada
	;no caso do inicio do jogo
	mov bolinhaParada, 1
	call desenharFundo
	
	mov posicaoPauX, posicaoBarrinhaXInicial
	mov posicaoPauY, posicaoBarrinhaYInicial
	mov posicaoPau, posicaoBarrinhaInicial
	mov direcaoPau, PAU_PARADO

	mov posicaoBolinhaX, posicaoBolinhaXInicial
	mov posicaoBolinhaY, posicaoBolinhaYInicial
	mov posicaoBolinha, posicaoBolinhaInicial
	mov vetorDirecaoBolinhaX, -2
	mov vetorDirecaoBolinhaY, -2
	
fimColisao:
	;nao estah na area dos boxs
	popa
	add sp, 10
	pop bp
	ret
	

verificaColisaoBox endP

;Funo que mostra a tela de abertura
mostraAbertura proc near
	pusha

	;Coloco em ax o offset da minha tela de abertura para passar como parametro para  
	;a funcao  de desenhar
	mov ax, offset telaAbertura
	desenharBitmap ax
	
	;Se o cara pressionar uma tecla ele sai da, retorna o scan code da tecla pressionada
	;no reg ah
	call getch 
	
	popa
	ret
mostraAbertura endP

;Funo que mostra a tela de gameOver
mostraGameOver proc near
	pusha

	;Coloco em ax o offset da minha tela de abertura para passar como parametro para  
	;a funcao  de desenhar
	mov ax, offset telaGameOver
	desenharBitmap ax
	
	;Se o cara pressionar uma tecla ele sai da
	call getch 
	;Vejo se a tecla foi Y(o cara quer jogar novamente)
	cmp ah, 15h
	je continuarJogo
	;Se o cara no quis jogar de novo eu seto a variavel global que diz se
	;ele vai ou nao jogar outra partida
	mov jogarNovamente,0	
	jmp fimFuncao
	
continuarJogo:
	;call inicializarJogo
	;Seto a variavel que avisa a main para voltar para o comeo da animao
	;J que cmecou o jogo de novo
	mov jogarNovamente, 1
	
fimFuncao:
	popa
	ret
mostraGameOver endP

;Funo que mostra a tela de quando o cara zerou o jogo
mostraZerou proc near
pusha

	;Coloco em ax o offset da minha tela de zerou para passar como parametro para  
	;a funcao  de desenhar
	mov ax, offset telaZerou
	desenharBitmap ax
	
	;Se o cara pressionar uma tecla ele sai da, retorna o scan code da tecla pressionada
	;no reg ah
	
	call getch 
	;Vejo se a tecla foi Y(o cara quer jogar novamente)
	cmp ah, 15h
	je continuarJogoZerou
	;Se o cara no quis jogar de novo eu seto a variavel global que diz se
	;ele vai ou nao jogar outra partida
	mov jogarNovamente,0	
	jmp fimFuncaoZerou
	
continuarJogoZerou:
	;call inicializarJogo
	;Seto a variavel que avisa a main para voltar para o comeo da animao
	;J que cmecou o jogo de novo
	mov jogarNovamente, 1
fimFuncaoZerou:
	popa
	ret
mostraZerou endP

;---------------------------------------------------------
;Desenha uma string na tela
desenharString macro enderecoString, posicaoStringX, posicaoStringY, corString, corFundoString
	push enderecoString
	push posicaoStringX
	push posicaoStringY
	push corString
	push corFundoString
	call desenharStringProc
endM

;---------------------------------------------------------
;Imprime uma string na tela na posicao desejada
;@param enderecoStringDS offset da variavel na memoria
enderecoStringDS	equ 12[bp]
;@param posicaoStringXDS posicao x (coluna) 
;		  em que a string vai ser impressa
posicaoStringXDS	equ 10[bp]
;@param posicaoStringYDS posicao y (linha) 
;		  em que a string vai ser impressa
posicaoStringYDS	equ  8[bp]
;@param corStringDS cor da string
corStringDS			equ  6[bp]
;@param corFundoStringDS cor do fundo da string
corFundoStringDS	equ  4[bp]

desenharStringProc proc near
	push bp
	mov bp, sp
	pusha
	mov bl, corStringDS
	mov bh, [corFundoStringDS] ;pagina de video
	mov si, enderecoStringDS
loopDesenharString:
	mov ax, posicaoStringXDS
	mov cx, posicaoStringYDS
	setarPosicaoTela 	al, cl
	;prepara para chamar a interrupcao 10h,A
	mov ah, 0Ah
	mov al, [si]
	;se terminou a string ('\0')
	cmp al, 0
	je fimDS
	mov cx, 1 ;repeticao de cada caractere
	int 10h
	inc si
	inc word ptr posicaoStringXDS
	jmp loopDesenharString
fimDS:
	popa
	pop bp
	ret 10
desenharStringProc endP


;---------------------------------------------------------
;Funcao para transformar um numero numa string
;@param itoaNumero numero que vai virar string
itoaNumero equ 4[bp]

itoa proc near
	push bp
	mov bp, sp
	pusha
	;coloca os operandos da divisao no lugar certo
	;quantidade de digitos do numero (16 bits gera no maximo ateh (2^16 - 1) = 65535)
	mov bx, 5 
	;coloca o 0 na ultima posicao da string
	mov itoaReturn[bx], 0
	dec bx
	mov di, 0 ; contador do laco
	mov cx, 10 ; divisor
loopItoa:
	xor dx, dx ;zera dx pq a divisao eh soh de 16 bits (soh usa ax)
	mov ax, itoaNumero ; coloca o numero para ax
	div cx ; divide ax por cx (ax/10)
	add dl, '0' ; soma o resto da divisao com o caractere '0' (para gerar um numero)
	mov itoaReturn[bx], dl ;coloca o numero na string
	mov itoaNumero, ax ; coloca o quociente no numero novamente
	dec bx ;pula para outra posicao da tring
	
	inc di ; incrementa o contador de digitos
	cmp di, 4 ; verifica se eh o ultimo digito
	je fimItoa ; sai do laco
	jmp loopItoa ; volta para o inicio do laco
fimItoa:
	add al, '0'; pega o ultimo quociente e coloca na primeira posicao da string
	mov itoaReturn[bx], al
	
	popa
	pop bp
	ret 2
itoa endP

;Funcao q carrega todos os arquivos do jogo
carregarArquivos proc near
	pusha
	
	mov dx, offset paletaName
	mov ax, offset paleta
	carregarBitmap dx, ax
	
	
	mov dx, offset f1LogoName
	mov ax, offset f1Logo
	carregarBitmap dx, ax
	
	mov dx, offset paleta
	mov cx, 100h
	setarPaleta dx, cx 
	
	mov dx, offset pauName
	mov ax, offset pau
	carregarBitmap dx, ax
	
	;Carregar as sprites
	mov dx, offset coracaoName
	mov ax, offset coracao
	carregarBitmap dx, ax
	
	mov dx, offset carinhaName
	mov ax, offset carinha
	carregarBitmap dx, ax
	
	mov dx, offset pocaoName
	mov ax, offset pocao
	carregarBitmap dx, ax
	
	mov dx, offset bloco1Name
	mov ax, offset bloco1
	carregarBitmap dx, ax
	
	mov dx, offset arquivoPontos
	mov ax, offset ultimoScore
	carregarBitmap dx, ax
	
	mov dx, offset bloco2Name
	mov ax, offset bloco2
	carregarBitmap dx, ax
	
	mov dx, offset bloco3Name
	mov ax, offset bloco3
	carregarBitmap dx, ax

	mov dx, offset bolinhaName
	mov ax, offset bolinha
	carregarBitmap dx, ax
	
	mov dx, offset blocoEspecialName
	mov ax, offset blocoEspecial
	carregarBitmap dx, ax
	
	mov dx, offset logoName
	mov ax, offset logo
	carregarBitmap dx, ax
	
	popa
	ret
carregarArquivos endP


;Funo usada para quando o jogo e inicializado
inicializarJogo proc near
	pusha

	;Zerar o score
	mov pontos, 0
	;Voltar pro 1o estagio
	mov numeroEstagios, 1
	;Para eu setar q nao mudou de estagio ja q comecou uma nova partida
	mov mudouEstagio, 0
	;Resetar a quantidade de vidas
	mov vidas, numeroVidas
	;Voltar a posicao da bolinha e da barrinha
	mov posicaoPauX, posicaoBarrinhaXInicial
	mov posicaoPauY, posicaoBarrinhaYInicial
	mov posicaoPau, posicaoBarrinhaInicial
	mov direcaoPau, PAU_PARADO

	mov posicaoBolinhaX, posicaoBolinhaXInicial
	mov posicaoBolinhaY, posicaoBolinhaYInicial
	mov posicaoBolinha, posicaoBolinhaInicial
	mov vetorDirecaoBolinhaX, -2
	mov vetorDirecaoBolinhaY, -2
	
	;Seto q o jogo nao acabou
	mov acabou, 0
	
	;Zero os spritea atuais
	mov spriteAtualCarinha, 0
	mov spriteAtualCoracao, 0
	mov spriteAtualPocao, 0
	
	;Zero os enables das sprites
	mov coracaoEnable, 0
	mov pocaoEnable, 0
	mov bolinhaParada, 1
	popa
	ret
inicializarJogo endP

mostrarFundoJogo proc near
	pusha 
	;Para desenhar um quadrado na tela com a cor 159
	desenharQuadrado 0, 200, 320, 1 ;1 eh preto!
	
	;Para desenhar um quadrado na tela com a cor 0
	desenharQuadrado 642, 196, 206, 185
	desenharQuadrado 849, 196, 2, 0
	
	mov ax, offset logo
	;desenharBitmapPosicao ax, coracaoPos, spriteAltura, spriteLargura 
	desenharBitmapPosicao ax, 6637, 14, 50   ;12x237   ; 237x20
	
	mov ax, offset f1Logo
	;desenharBitmapPosicao ax, coracaoPos, spriteAltura, spriteLargura 
	desenharBitmapPosicao ax, 53020, 30, 62   ;12x237   ; 237x20
	
	popa
	ret
mostrarFundoJogo endP


mostrarHelp proc near
	pusha
	;Coloco em ax o offset da minha tela de abertura para passar como parametro para  
	;a funcao  de desenhar
	mov ax, offset helpName
	desenharBitmap ax
	
	;Se o cara pressionar uma tecla ele sai da, retorna o scan code da tecla pressionada
	;no reg ah
	call getch 
	mov help, 0
	mov pause, 0
	call mostrarFundoJogo
	popa
	ret
mostrarHelp endP

atualizarUltimoScore proc near
	pusha
	push offset arquivoPontos
	call escreverArquivoProc
	mov ax, offset arquivoPontos
	mov dx, offset ultimoScore
	carregarBitmap ax, dx
	;mov ax, pontos
	;mov ultimoScore, ax
	popa 
	ret
atualizarUltimoScore endP

main:
	
	;Desabilita as interrupes
	cli
	
	;Bota os ds pro de dados, etc...
	inicializarMain
	setarModoGrafico	
	
	call carregarArquivos
;mostraTelaAbertura:
	;Mando mostrar a tela de abertura
	call mostraAbertura
	
	
inicioDeJogo:
	;Mando inicializar o jogo
	call inicializarJogo 
	;Carrega o arquivo com os boxes
	mov al, '1'
	mov bx, 5
	mov boxsName[bx], al
	mov dx, offset boxsName
	mov ax, offset boxs
	carregarBitmap dx, ax
	
	;Mando contar quantos quadrados ativos existem no estagio
	call contaBoxes
	
	;Seta o tickrate do timer
	mov cx, offset timerProc
	mov tickrate, 15500
	
	;Seta o timer
	setarTimer cx, tickrate
	
	;mov dx, offset bitmapName
	;desenharBitmap dx
	
	call mostrarFundoJogo
	
	;mov pontos, 0
	;Habilita as interrupes
	sti
	call desenharPau
	mov cx, limiteVida

animacao:
	cmp acabou, 1
	je fim
	cmp help, 1
	je mostraHelp
	mov dx, 0
	mov ax, pontos
	;divide ax por 1000 e coloca o resto em dx e o quociente em ax
	div cx
	cmp coracaoEnable, 1
	je testaProximoEstagio
	cmp ax, 0
	jg incrementaVidas
	jmp testaProximoEstagio
	incrementaVidas:
		;inc vidas
		;inc pontos
		add cx, limiteVida
		
		;Seto a posicao Inicial do coracaozinho
		mov ax, posicaoBolinhaX
		;vejo se ele passou da area cinza...
		cmp ax, 188
		jge voltaCoracaoDir
		jmp naoVoltaCoracao
	voltaCoracaoDir:
		;se ele passou da area cinza ele volta pra direita.
		mov ax, 187
	naoVoltaCoracao:
		mov coracaoPosX, ax
		;posicao inicial do coracao Y
		mov coracaoPosY, 108
		
		;Calculo a posicao
		mov bx, coracaoPosY
		; o endereco que vou escrever eh: (y*320) + x
		; y*320 = y*256 + y*64
		sal bx, 6
		mov ax, bx
		sal bx, 2
		add ax, bx
		;soma a coluna
		mov dx, coracaoPosX
		add ax, dx
		mov coracaoPos, ax
		
		;Seto para baixar o coracaozinho
		mov coracaoEnable, 1
		
	testaProximoEstagio:
		cmp numeroQuadrados, 0
		je proximoEstagio
		jmp animacao
	mostraHelp:
		call mostrarHelp
		jmp animacao
	
	proximoEstagio:
		;Incrementa o numero do estgio
		inc numeroEstagios
		mov passaLotado, 0
		;Seto um flag dizendo q mudou o estagio para  o timer nao redesenhar tudo
		mov mudouEstagio, 1
		
		;Vejo se ja esgotou o numero de estagios
		mov al, totalEstagios
		cmp numeroEstagios, al
		jg acabouEstagios

		;Para eu transformar o numero de estagios em um caracter eu tenho q somar com o
		;'0' para eu poder colocar na posico 5 do nome, ja q o nome do arquivo eh BoxsXX.bin
		;Esse XX eh o numero do meu estgio
		mov al, numeroEstagios
		add al, '0'
		mov bx, 5
		mov boxsName[bx], al
	
		;Para carregar o arquivo do estagio selecionado
		mov dx, offset boxsName
		mov ax, offset boxs
		carregarBitmap dx, ax
		
		;Mando contar os boxes do estagio
		call contaBoxes
		
		;Mando para o comeo da animao
		jmp animacao
		
	acabouEstagios:
		resetarTimer
		;O cara zerou o jogo
		call mostraZerou
		mov ax, pontos
		mov dx, ultimoScore
		cmp dx, ax
		jge vaiProInicio
		;desenharString dx, 68, 2, 8, 60
		;Movo paa dx a variavel q contem a string "Pontos: "
		call atualizarUltimoScore
		jmp vaiProInicio
	
	fim:
		resetarTimer
		;Vejo se o cara quer jogar novamente ou nao, se sim eu mando inicializar o jogo
		call mostraGameOver
		mov ax, pontos
		mov dx, ultimoScore
		cmp dx, ax
		jge vaiProInicio
		;desenharString dx, 68, 2, 8, 60
		;Movo paa dx a variavel q contem a string "Pontos: "
		call atualizarUltimoScore
				
	vaiProInicio:
		cmp jogarNovamente, 1
		je inicioDeJogo
		
	setaModoTexto:
		setarModoTexto
		mov ax, pontos
		cmp ultimoScore, ax
		jge fimDosFins
		push offset arquivoPontos
		call escreverArquivoProc
	fimDosFins:
		sair	
		
end main
